#ifndef HUFF_H
#define HUFF_H

#include <stdlib.h>
#include <stdio.h>
#define NNODE       13
#define nchar       7
typedef struct tnode
{
    struct  tnode*left; /*used when in tree*/
    struct  tnode*right; /*used when in tree*/
    struct  tnode*parent;/*used when in tree*/
    float   freq;
    int     isleaf;
    char    symbol;
} tree_node;

typedef struct encode
{
    int len;
    char code_word[5];
}code_inf;

/*global variables*/
extern code_inf code[NNODE];
extern tree_node temp[NNODE];
extern tree_node* ptemp[NNODE];


/*function prototype*/
int compare(const void*s1, const void*s2);
void generate_code();
int encode(char chara);
#endif
